CREATE TABLE [dbo].[GROUPS](
	[GRP_ID] [int] IDENTITY(1,1) NOT NULL,
	[GRP_NAME] [varchar](50) NOT NULL,
	[GRP_ALLOWED_DOCTYPES] [varchar](255) NOT NULL,
	[GRP_ABN_TYPE] [varchar](50) NOT NULL
 CONSTRAINT [PK_USER_GROUPS] PRIMARY KEY CLUSTERED 
(
	[GRP_ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY];

INSERT INTO [dbo].[GROUPS] (GRP_NAME, GRP_ALLOWED_DOCTYPES,GRP_ABN_TYPE) VALUES ('  ','',''); 


CREATE TABLE [dbo].[USERS_GROUPS](
	[UG_ID] [int] IDENTITY(1,1) NOT NULL,
	[UG_USER_ID] [int] NOT NULL,
	[UG_GROUP_ID] [int] NOT NULL,
 CONSTRAINT [PK_USERS_GROUPS] PRIMARY KEY CLUSTERED 
(
	[UG_ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY];

ALTER TABLE [dbo].[USERS_GROUPS]  WITH CHECK ADD  CONSTRAINT [FK_USERS_GROUPS_GROUPS] FOREIGN KEY([UG_GROUP_ID])
REFERENCES [dbo].[GROUPS] ([GRP_ID]);
ALTER TABLE [dbo].[USERS_GROUPS] CHECK CONSTRAINT [FK_USERS_GROUPS_GROUPS];
ALTER TABLE [dbo].[USERS_GROUPS]  WITH CHECK ADD  CONSTRAINT [FK_USERS_GROUPS_USERS] FOREIGN KEY([UG_USER_ID])
REFERENCES [dbo].[USERS] ([USER_ID]);
ALTER TABLE [dbo].[USERS_GROUPS] CHECK CONSTRAINT [FK_USERS_GROUPS_USERS];
ALTER TABLE [dbo].[DOCS] ADD DOC_GROUP_ID int not NULL DEFAULT(1);
ALTER TABLE [dbo].[DOCS]  WITH CHECK ADD  CONSTRAINT [FK_DOCS_GROUPS] FOREIGN KEY([DOC_GROUP_ID])
REFERENCES [dbo].[GROUPS] ([GRP_ID]);
ALTER TABLE [dbo].[DOCS] CHECK CONSTRAINT [FK_DOCS_GROUPS];

sp_refreshview V_DOCUMENTS;

GRANT SELECT ON [dbo].[GROUPS] TO [CourierUser];

GRANT SELECT ON [dbo].[USERS_GROUPS] TO [CourierUser];

CREATE VIEW [dbo].[V_BASE_GROUP_DOCS_ID]
AS
SELECT        DOC_ID
FROM            dbo.DOCS
WHERE        DOC_GROUP_ID IN
                             (SELECT        UG_GROUP_ID
                               FROM            dbo.USERS_GROUPS AS USERS_GROUPS_1
                               WHERE        UG_USER_ID IN
                                                             (SELECT        USER_ID AS Expr1
                                                               FROM            dbo.USERS AS USERS_2
                                                               WHERE        USER_LOGIN = USER AND (USER_ABN_ID=DOC_RECIPIENT_ABN_ID OR USER_ABN_ID=DOC_SENDER_ABN_ID)))
WITH CHECK OPTION;

CREATE VIEW [dbo].[V_GROUP_DOCS_ID]
AS
SELECT        DOC_ID
FROM            dbo.DOCS
WHERE        (DOC_INCOMING = CAST(1 AS bit)) AND (DOC_RECIPIENT_ABN_ID IN
                             (SELECT        USER_ABN_ID
                               FROM            dbo.USERS
                               WHERE        (USER_LOGIN = USER) AND (USER_DELETED = CAST(0 AS bit)) AND (USER_NAME <> ' '))) 
							   AND DOC_ID IN (SELECT DOC_ID FROM V_BASE_GROUP_DOCS_ID)
							    OR
                         (DOC_INCOMING = CAST(0 AS bit)) AND (DOC_SENDER_ABN_ID IN
                             (SELECT        USER_ABN_ID
                               FROM            dbo.USERS AS USERS_1
                               WHERE        (USER_LOGIN = USER) AND (USER_DELETED = CAST(0 AS bit)) AND (USER_NAME <> ' '))) 
							   AND DOC_ID IN (SELECT DOC_ID FROM V_BASE_GROUP_DOCS_ID);

CREATE VIEW [dbo].[V_GROUP_INDOCS_ID]
AS
SELECT DOC_ID FROM dbo.DOCS
WHERE (DOC_RECIPIENT_ABN_ID IN (SELECT USER_ABN_ID FROM dbo.USERS

WHERE (USER_LOGIN = USER) AND USER_DELETED=CAST(0 as bit)))
 AND DOC_ID IN (SELECT DOC_ID FROM V_BASE_GROUP_DOCS_ID);

CREATE VIEW [dbo].[V_GROUP_OUTDOCS_ID]
AS
SELECT DOC_ID FROM dbo.DOCS
WHERE (DOC_SENDER_ABN_ID IN (SELECT USER_ABN_ID FROM dbo.USERS

WHERE (USER_LOGIN = USER) AND USER_DELETED=CAST(0 as bit)))
AND DOC_ID IN (SELECT DOC_ID FROM V_BASE_GROUP_DOCS_ID);

CREATE VIEW [dbo].[V_GROUP_DOCUMENTS]
AS
SELECT * FROM dbo.DOCS
WHERE DOC_ID IN (SELECT DOC_ID FROM dbo.V_GROUP_DOCS_ID)
WITH CHECK OPTION
;

CREATE VIEW [dbo].[V_GROUP_FILESTORE]
AS
SELECT * FROM dbo.FILESTORE
WHERE FILE_DOC_ID IN (SELECT DOC_ID FROM dbo.V_GROUP_DOCS_ID)
WITH CHECK OPTION

;


CREATE VIEW [dbo].[V_GROUP_DOC_SIGNATURES]
AS
SELECT * FROM dbo.DOC_SIGNATURES
WHERE DS_DOC_ID IN (SELECT DOC_ID FROM dbo.V_GROUP_DOCS_ID)
WITH CHECK OPTION

;

CREATE VIEW [dbo].[V_GROUP_DOC_HISTORY]
AS
SELECT * FROM dbo.DOC_HISTORY
WHERE DH_DOC_ID IN (SELECT DOC_ID FROM dbo.V_GROUP_DOCS_ID)
WITH CHECK OPTION

;

CREATE VIEW [dbo].[V_GROUP_DOC_HEADERS]
AS
SELECT * FROM dbo.DOC_HEADERS
WHERE HEADER_DOC_ID IN (SELECT DOC_ID FROM dbo.V_GROUP_DOCS_ID)
WITH CHECK OPTION

;

CREATE VIEW [dbo].[V_GROUP_DOC_CONTENT]
AS
SELECT * FROM dbo.DOC_CONTENT
WHERE DC_DOC_ID IN (SELECT DOC_ID FROM dbo.V_GROUP_DOCS_ID)
WITH CHECK OPTION

;

CREATE VIEW [dbo].[V_GROUP_DOC_ATTACHMENTS]
AS
SELECT * FROM dbo.DOC_ATTACHMENTS
WHERE ATT_DOC_ID IN (SELECT DOC_ID FROM dbo.V_GROUP_DOCS_ID)
WITH CHECK OPTION
;

CREATE ROLE [CourierGroupUser] AUTHORIZATION [dbo];
CREATE SCHEMA [CourierGroupUserSchema] AUTHORIZATION [dbo];
CREATE SYNONYM [CourierGroupUserSchema].[FILESTORE] FOR [V_GROUP_FILESTORE];
CREATE SYNONYM [CourierGroupUserSchema].[DOCS] FOR [V_GROUP_DOCUMENTS];
CREATE SYNONYM [CourierGroupUserSchema].[DOC_SIGNATURES] FOR [V_GROUP_DOC_SIGNATURES];
CREATE SYNONYM [CourierGroupUserSchema].[DOC_HISTORY] FOR [V_GROUP_DOC_HISTORY];
CREATE SYNONYM [CourierGroupUserSchema].[DOC_HEADERS] FOR [V_GROUP_DOC_HEADERS];
CREATE SYNONYM [CourierGroupUserSchema].[DOC_CONTENT] FOR [V_GROUP_DOC_CONTENT];
CREATE SYNONYM [CourierGroupUserSchema].[DOC_ATTACHMENTS] FOR [V_GROUP_DOC_ATTACHMENTS];
GRANT DELETE ON [CourierGroupUserSchema].[DOC_ATTACHMENTS] TO [CourierGroupUser];
GRANT INSERT ON [CourierGroupUserSchema].[DOC_ATTACHMENTS] TO [CourierGroupUser];
GRANT SELECT ON [CourierGroupUserSchema].[DOC_ATTACHMENTS] TO [CourierGroupUser];
GRANT UPDATE ON [CourierGroupUserSchema].[DOC_ATTACHMENTS] TO [CourierGroupUser];
GRANT DELETE ON [CourierGroupUserSchema].[DOC_CONTENT] TO [CourierGroupUser];
GRANT INSERT ON [CourierGroupUserSchema].[DOC_CONTENT] TO [CourierGroupUser];
GRANT SELECT ON [CourierGroupUserSchema].[DOC_CONTENT] TO [CourierGroupUser];
GRANT UPDATE ON [CourierGroupUserSchema].[DOC_CONTENT] TO [CourierGroupUser];
GRANT DELETE ON [CourierGroupUserSchema].[DOC_HEADERS] TO [CourierGroupUser];
GRANT INSERT ON [CourierGroupUserSchema].[DOC_HEADERS] TO [CourierGroupUser];
GRANT SELECT ON [CourierGroupUserSchema].[DOC_HEADERS] TO [CourierGroupUser];
GRANT UPDATE ON [CourierGroupUserSchema].[DOC_HEADERS] TO [CourierGroupUser];
GRANT DELETE ON [CourierGroupUserSchema].[DOC_HISTORY] TO [CourierGroupUser];
GRANT INSERT ON [CourierGroupUserSchema].[DOC_HISTORY] TO [CourierGroupUser];
GRANT SELECT ON [CourierGroupUserSchema].[DOC_HISTORY] TO [CourierGroupUser];
GRANT UPDATE ON [CourierGroupUserSchema].[DOC_HISTORY] TO [CourierGroupUser];
GRANT DELETE ON [CourierGroupUserSchema].[DOC_SIGNATURES] TO [CourierGroupUser];
GRANT INSERT ON [CourierGroupUserSchema].[DOC_SIGNATURES] TO [CourierGroupUser];
GRANT SELECT ON [CourierGroupUserSchema].[DOC_SIGNATURES] TO [CourierGroupUser];
GRANT UPDATE ON [CourierGroupUserSchema].[DOC_SIGNATURES] TO [CourierGroupUser];
GRANT DELETE ON [CourierGroupUserSchema].[DOCS] TO [CourierGroupUser];
GRANT INSERT ON [CourierGroupUserSchema].[DOCS] TO [CourierGroupUser];
GRANT SELECT ON [CourierGroupUserSchema].[DOCS] TO [CourierGroupUser];
GRANT UPDATE ON [CourierGroupUserSchema].[DOCS] TO [CourierGroupUser];
GRANT DELETE ON [CourierGroupUserSchema].[FILESTORE] TO [CourierGroupUser];
GRANT INSERT ON [CourierGroupUserSchema].[FILESTORE] TO [CourierGroupUser];
GRANT SELECT ON [CourierGroupUserSchema].[FILESTORE] TO [CourierGroupUser];
GRANT UPDATE ON [CourierGroupUserSchema].[FILESTORE] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[ABONENTS] TO [CourierGroupUser];
GRANT UPDATE ON [dbo].[ABONENTS] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[ACCESS_RIGHTS] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[CERTIFICATES] TO [CourierGroupUser];
GRANT UPDATE ON [dbo].[CERTIFICATES] TO [CourierGroupUser];
GRANT DELETE ON [dbo].[DOC_BLOCKINGS] TO [CourierGroupUser];
GRANT INSERT ON [dbo].[DOC_BLOCKINGS] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[DOC_BLOCKINGS] TO [CourierGroupUser];
GRANT UPDATE ON [dbo].[DOC_BLOCKINGS] TO [CourierGroupUser];
GRANT INSERT ON [dbo].[DOC_TYPES] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[DOC_TYPES] TO [CourierGroupUser];
GRANT UPDATE ON [dbo].[DOC_TYPES] TO [CourierGroupUser];
GRANT DELETE ON [dbo].[REFERENCE] TO [CourierGroupUser];
GRANT INSERT ON [dbo].[REFERENCE] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[REFERENCE] TO [CourierGroupUser];
GRANT UPDATE ON [dbo].[REFERENCE] TO [CourierGroupUser];
GRANT DELETE ON [dbo].[UPDATES] TO [CourierGroupUser];
GRANT INSERT ON [dbo].[UPDATES] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[UPDATES] TO [CourierGroupUser];
GRANT UPDATE ON [dbo].[UPDATES] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[USER_ROLES] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[USERS] TO [CourierGroupUser];
GRANT DELETE ON [dbo].[V_GROUP_DOC_ATTACHMENTS] TO [CourierGroupUser];
GRANT INSERT ON [dbo].[V_GROUP_DOC_ATTACHMENTS] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[V_GROUP_DOC_ATTACHMENTS] TO [CourierGroupUser];
GRANT UPDATE ON [dbo].[V_GROUP_DOC_ATTACHMENTS] TO [CourierGroupUser];
GRANT DELETE ON [dbo].[V_GROUP_DOC_CONTENT] TO [CourierGroupUser];
GRANT INSERT ON [dbo].[V_GROUP_DOC_CONTENT] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[V_GROUP_DOC_CONTENT] TO [CourierGroupUser];
GRANT UPDATE ON [dbo].[V_GROUP_DOC_CONTENT] TO [CourierGroupUser];
GRANT DELETE ON [dbo].[V_GROUP_DOC_HEADERS] TO [CourierGroupUser];
GRANT INSERT ON [dbo].[V_GROUP_DOC_HEADERS] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[V_GROUP_DOC_HEADERS] TO [CourierGroupUser];
GRANT UPDATE ON [dbo].[V_GROUP_DOC_HEADERS] TO [CourierGroupUser];
GRANT DELETE ON [dbo].[V_GROUP_DOC_HISTORY] TO [CourierGroupUser];
GRANT INSERT ON [dbo].[V_GROUP_DOC_HISTORY] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[V_GROUP_DOC_HISTORY] TO [CourierGroupUser];
GRANT UPDATE ON [dbo].[V_GROUP_DOC_HISTORY] TO [CourierGroupUser];
GRANT DELETE ON [dbo].[V_GROUP_DOC_SIGNATURES] TO [CourierGroupUser];
GRANT INSERT ON [dbo].[V_GROUP_DOC_SIGNATURES] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[V_GROUP_DOC_SIGNATURES] TO [CourierGroupUser];
GRANT UPDATE ON [dbo].[V_GROUP_DOC_SIGNATURES] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[V_GROUP_DOCS_ID] TO [CourierGroupUser];
GRANT DELETE ON [dbo].[V_GROUP_DOCUMENTS] TO [CourierGroupUser];
GRANT INSERT ON [dbo].[V_GROUP_DOCUMENTS] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[V_GROUP_DOCUMENTS] TO [CourierGroupUser];
GRANT UPDATE ON [dbo].[V_GROUP_DOCUMENTS] TO [CourierGroupUser];
GRANT DELETE ON [dbo].[V_GROUP_FILESTORE] TO [CourierGroupUser];
GRANT INSERT ON [dbo].[V_GROUP_FILESTORE] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[V_GROUP_FILESTORE] TO [CourierGroupUser];
GRANT UPDATE ON [dbo].[V_GROUP_FILESTORE] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[V_GROUP_INDOCS_ID] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[V_GROUP_OUTDOCS_ID] TO [CourierGroupUser];
GRANT INSERT ON [dbo].[CERTIFICATES] TO [CourierGroupUser];
GRANT UPDATE ON [dbo].[CERTIFICATES] TO [CourierGroupUser];
GRANT SELECT, INSERT, UPDATE ON V_REMOTE_ABONENTS TO CourierGroupUser;
GRANT SELECT, INSERT, UPDATE, DELETE ON V_REMOTE_USERS TO CourierGroupUser;
GRANT DELETE ON [dbo].[ABN_BLOCKINGS] TO [CourierGroupUser];
GRANT INSERT ON [dbo].[ABN_BLOCKINGS] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[ABN_BLOCKINGS] TO [CourierGroupUser];
GRANT UPDATE ON [dbo].[ABN_BLOCKINGS] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[GROUPS] TO [CourierGroupUser];
GRANT SELECT ON [dbo].[USERS_GROUPS] TO [CourierGroupUser];

CREATE ROLE [CourierPowerUser] AUTHORIZATION [dbo];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[ABN_BLOCKINGS] TO [CourierPowerUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[ABONENTS] TO [CourierPowerUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[ACCESS_RIGHTS] TO [CourierPowerUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[CERTIFICATES] TO [CourierPowerUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[DOC_ATTACHMENTS] TO [CourierPowerUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[DOC_BLOCKINGS] TO [CourierPowerUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[DOC_CONTENT] TO [CourierPowerUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[DOC_HEADERS] TO [CourierPowerUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[DOC_HISTORY] TO [CourierPowerUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[DOC_SIGNATURES] TO [CourierPowerUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[DOC_TYPES] TO [CourierPowerUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[DOCS] TO [CourierPowerUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[FILESTORE] TO [CourierPowerUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[GROUPS] TO [CourierPowerUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[REFERENCE] TO [CourierPowerUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[UPDATES] TO [CourierPowerUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[USER_ROLES] TO [CourierPowerUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[USERS] TO [CourierPowerUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[USERS_GROUPS] TO [CourierPowerUser];

INSERT INTO [dbo].[GROUPS] (GRP_NAME, GRP_ALLOWED_DOCTYPES,GRP_ABN_TYPE) VALUES (' (01 )','NALOGXML534;NALOG534','');
INSERT INTO [dbo].[GROUPS] (GRP_NAME, GRP_ALLOWED_DOCTYPES,GRP_ABN_TYPE) VALUES ('  (02 )','NALOG534NPLETTER',''); 
INSERT INTO [dbo].[GROUPS] (GRP_NAME, GRP_ALLOWED_DOCTYPES,GRP_ABN_TYPE) VALUES ('  (03 )','NALOG534IN 03_01','');
INSERT INTO [dbo].[GROUPS] (GRP_NAME, GRP_ALLOWED_DOCTYPES,GRP_ABN_TYPE) VALUES (' (04 )','NALOG534IN 04_01',''); 
INSERT INTO [dbo].[GROUPS] (GRP_NAME, GRP_ALLOWED_DOCTYPES,GRP_ABN_TYPE) VALUES ('  (05 )','NALOG534IN 05_01',''); 
INSERT INTO [dbo].[GROUPS] (GRP_NAME, GRP_ALLOWED_DOCTYPES,GRP_ABN_TYPE) VALUES (' (06 )','NALOGION534',''); 
INSERT INTO [dbo].[GROUPS] (GRP_NAME, GRP_ALLOWED_DOCTYPES,GRP_ABN_TYPE) VALUES (' 2 (08 )','NALOG534NDFL',''); 
INSERT INTO [dbo].[GROUPS] (GRP_NAME, GRP_ALLOWED_DOCTYPES,GRP_ABN_TYPE) VALUES (' (09 )','TCZAYAV534',''); 
INSERT INTO [dbo].[GROUPS] (GRP_NAME, GRP_ALLOWED_DOCTYPES,GRP_ABN_TYPE) VALUES (' (10 )','NALOG534IN 10_01',''); 
INSERT INTO [dbo].[GROUPS] (GRP_NAME, GRP_ALLOWED_DOCTYPES,GRP_ABN_TYPE) VALUES (' (11 )','FVBG534',''); 
INSERT INTO [dbo].[GROUPS] (GRP_NAME, GRP_ALLOWED_DOCTYPES,GRP_ABN_TYPE) VALUES (' (12 )','UT229',''); 
INSERT INTO [dbo].[GROUPS] (GRP_NAME, GRP_ALLOWED_DOCTYPES,GRP_ABN_TYPE) VALUES (' (13 )','UCHASTNIK',''); 
INSERT INTO [dbo].[GROUPS] (GRP_NAME, GRP_ALLOWED_DOCTYPES,GRP_ABN_TYPE) VALUES (' ','',''); 
INSERT INTO [dbo].[GROUPS] (GRP_NAME, GRP_ALLOWED_DOCTYPES,GRP_ABN_TYPE) VALUES (' ','',''); 
INSERT INTO [dbo].[GROUPS] (GRP_NAME, GRP_ALLOWED_DOCTYPES,GRP_ABN_TYPE) VALUES ('','',''); 
INSERT INTO [dbo].[GROUPS] (GRP_NAME, GRP_ALLOWED_DOCTYPES,GRP_ABN_TYPE) VALUES (' ',' ',''); 
INSERT INTO [dbo].[GROUPS] (GRP_NAME, GRP_ALLOWED_DOCTYPES,GRP_ABN_TYPE) VALUES ('','',''); 
INSERT INTO [dbo].[GROUPS] (GRP_NAME, GRP_ALLOWED_DOCTYPES,GRP_ABN_TYPE) VALUES (' ','',''); 